' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2007-2008
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'

const SUCCESS = 254
const BAD_ARG_COUNT = 1
const INVALID_KEY = 2
const ACCESS_DENIED = 9
const NO_STD_REG_PROV = 8

const HKLM = &H80000002
On Error Resume Next

Set args = WScript.Arguments
if args.count <> 3  Then
    Wscript.Quit(BAD_ARG_COUNT)         
end If

if (UCASE(args.Item(0)) = "RECURSE") then
    recurse = true
else
    recurse = false
end if

keyPath = UCASE(args.Item(1))
target = UCASE(args.Item(2))
 
Set oShell = WScript.CreateObject("WScript.Shell") 
Set oCtx = CreateObject("WbemScripting.SWbemNamedValueSet")
if oShell.Environment("PROCESS")("PROCESSOR_ARCHITEW6432") <> "" then
	oCtx.Add "__ProviderArchitecture", 64
	oCtx.Add "__RequiredArchitecture", TRUE
end if

Set oLocator = CreateObject("Wbemscripting.SWbemLocator")
Set oServices = oLocator.ConnectServer("","root\default","","",,,,oCtx)
Set oReg = oServices.Get("StdRegProv") 

if IsEmpty(oReg) Then
    wscript.quit(NO_STD_REG_PROV)
end if

isKey = false
rVal = oReg.EnumKey(HKLM, keyPath, arrKeys)
if rVal <> 0 then
    classfyErrorAndExit(rVal)
else
    if isArray(arrKeys) then
        For each value in arrKeys
            value = UCASE(value)
            if value = target Then
                isKey = true
                exit for
            end if
        Next
    end if
end if    

fullPath = keyPath & "\" & target

if isKey then
    if recurse = false Then
        status = oReg.DeleteKey(HKLM, fullPath)
        if status <> 0 then
            classfyErrorAndExit(status)
        end if    
    else
        status = deleteRecurse(fullPath)
    end if
else
    status = oReg.DeleteValue(HKLM, keyPath, target)    
    if status <> 0 then
        classfyErrorAndExit(status)
    end if    
end if 

wscript.Quit(SUCCESS)
        
Function deleteRecurse(keyPath)
    On Error Resume Next
    rVal = oReg.EnumKey(HKLM, keyPath, arrSubKeys)
    if (rVal = 0) then 
        if isArray(arrSubKeys) then
            For each subkey in arrSubKeys
                rVal = deleteRecurse(keyPath & "\" & subKey)
                if rVal <> 0 then stat = -1
            Next
        end if    
    else
        classfyErrorAndExit(rVal)    
    end if
    rVal = oReg.DeleteKey(HKLM, KeyPath)
    if rVal <> 0 then 
        classfyErrorAndExit(rVal)
    end if    
End Function

Function classfyErrorAndExit(error_num)
    On Error Resume Next
     
    if error_num = 2 then
        wscript.Quit(INVALID_KEY)
    elseif error_num = 5 then
        wscript.Quit(ACCESS_DENIED)
    else            
        'unknown error
        wscript.Quit(0)    
    end if    
End Function
