' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2007-2008
'
' All Rights Reserved 
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
' Given a registry key path, return the keys type and value.  
' Use for listRegistryValueNames and getRegistryValueType
' Two args means give detail on single value. One arg means
'   list all value names/Types under path
const SUCCESS = 254
const BAD_ARG_COUNT = 1
const INVALID_KEY = 2
const INVALID_VALUE_NAME = 6
const NO_STD_REG_PROV = 8

const WMI_STATUS_INVALID_KEY_PATH = 2
const WMI_STATUS_INVALID_VALUE_NAME = 1

On Error Resume Next
Set args = WScript.Arguments

if args.count = 1 Then
    listKeys = True
    keyPath = args.Item(0)
Elseif args.count = 2 Then
    listKeys = False
    keyPath = args.Item(0)
    targetName = args.Item(1)
Else    
    Wscript.Quit(BAD_ARG_COUNT)    
End If    

'Allow query of HKLM
if (keyPath = "\") Then
    keyPath = ""
End If
const HKLM = &H80000002

const REG_SZ = 1
const REG_EXPAND_SZ = 2
const REG_BINARY = 3
const REG_DWORD = 4
const REG_MULTI_SZ = 7

Set oShell = WScript.CreateObject("WScript.Shell") 
Set oCtx = CreateObject("WbemScripting.SWbemNamedValueSet")
if oShell.Environment("PROCESS")("PROCESSOR_ARCHITEW6432") <> "" then
oCtx.Add "__ProviderArchitecture", 64
oCtx.Add "__RequiredArchitecture", TRUE
end if

Set oLocator = CreateObject("Wbemscripting.SWbemLocator")
Set oServices = oLocator.ConnectServer("","root\default","","",,,,oCtx)
Set oReg = oServices.Get("StdRegProv") 

if IsEmpty(oReg) Then
    wscript.quit(NO_STD_REG_PROV)
end if

rVal = oReg.EnumValues(HKLM, keyPath, values, types)
chkErr()
if rVal <> 0 then
    if rVal = WMI_STATUS_INVALID_KEY_PATH Then
        Wscript.Quit(INVALID_KEY)
    elseif rVal = WMI_STATUS_INVALID_VALUE_NAME Then
        Wscript.Quit(INVALID_VALUE_NAME)
    else     
        Wscript.Quit(0)
    end if   
end if     

matched = False
For I=0 To UBound(values)
    keyName = values(I)
    keyType =  types(I)
    
    if UCase(targetName) = UCase(keyName) Or listKeys = True Then
        if listKeys = False Then matched = True
        If keyType = 1 then
            printType = "REG_SZ"
        ElseIf keyType = 2 then
            printType = "REG_EXPAND_SZ"
        elseif keyType = 3 then
            printType = "REG_BINARY"
        elseif keyType = 4 then
            printType = "REG_DWORD"
        elseif keyType = 7 then
            printType = "REG_MULTI_SZ"
        else
            printType = "UNKNOWN"
        End if
        if listKeys = true Then WScript.Echo keyName
        if listKeys = False Then WScript.Echo printType
    End if    
Next

'check if requested value name did not exist
If listKeys = False and matched = false Then
    Wscript.Quit(INVALID_VALUE_NAME)
End If
    
Wscript.Quit(SUCCESS)
    
Function chkErr
    If Err > 0 Then
        WScript.StdErr.WriteLine Err.number
        WScript.StdErr.WriteLine Err.Description
        Wscript.Quit(0)
    End If    
End Function    